/*
Some rights reserved (CC) 2007
Code licensed under the Creative Commons license:
http://creativecommons.org/licenses/by-sa/2.5/

@author: Alexandre (amf)
*/


/**
 * The AMF global namespace
 * @constructor
 */
window.AMF = window.AMF || {};


AMF.voFactory = function(p_obj) {
	var _fcn = new Function();
	var _type, _defaultValue, _objValue;

	var _createVars = function() {
		for (var i = 0, l = p_obj.length; i < l; i++) {
			obj = p_obj[i];
			if (typeof obj === 'string') { p_obj[i] = []; p_obj[i][0] = obj; }

			if (obj[1] === undefined) { _objValue = ''; }
			else {
				_defaultValue = (obj[1].defaultValue !== undefined) ? obj[1].defaultValue : undefined;

				if (obj[1].type) {
					_type = obj[1].type.toLowerCase();
				} else { _type = ''; }

				switch (_type) {
					case 'array': _objValue = _defaultValue || []; break;
					case 'int': _objValue = parseInt(_defaultValue, 10) || 0; break;
					case 'float': _objValue = parseFloat(_defaultValue) || 0.0; break;
					case 'string': _objValue = _defaultValue || ''; break;
					case 'object': _objValue = _defaultValue || null; break;
					default: _objValue = ''; break;
				}
			}

			_fcn.prototype['_' + obj[0]] = _objValue;
		}
	};

	var _setGenerator = function (p_obj, p_type) {
		var dataTypes, algorithm, fcnTemplate;

		dataTypes = {
			'array': 'p_param',
			'int': 'parseInt(p_param)',
			'float': 'parseFloat(p_param)',
			'string': 'p_param.toString()',
			'boolean': 'p_param',
			'object': 'p_param',
			'undefined': 'p_param'
		};

		algorithm = (p_type !== '') ? dataTypes[p_type] : dataTypes['undefined'];
		fcnTemplate = 'if(p_param === undefined) { return; }; this._' + p_obj + '= ' + algorithm + ';';

		return fcnTemplate;
	};

	var _createGetSet = function() {
		var obj, firstLetter, methodName, addName;

		for (var i = 0, l = p_obj.length; i < l; i++) {
			obj = p_obj[i];
			firstLetter = obj[0].substr(0, 1).toUpperCase();
			methodName = firstLetter + obj[0].substr(1);

			if (obj[1]) {
				_defaultValue = (obj[1].defaultValue !== undefined) ? obj[1].defaultValue : undefined;

				if (obj[1].addName) {
					addName = obj[1].addName;
					firstLetter = addName.substr(0, 1).toUpperCase();
					addName = firstLetter + addName.substr(1);
				} else { addName = false; }

				if (obj[1].type) {
					_type = obj[1].type.toLowerCase();
				} else { _type = ''; }

				_fcn.prototype['set' + methodName] = new Function('p_param', _setGenerator(obj[0], _type));

				if (_type === 'array') {
					if (!addName) { addName = methodName; }
					_fcn.prototype['add' + addName] = new Function('p_param', 'if(p_param === undefined) { return; }; this._' +
						obj[0] + '.push(p_param);');
				}
			} else {
				_fcn.prototype['set' + methodName] = new Function('p_param', _setGenerator(obj[0]));
			}

			_fcn.prototype['get' + methodName] = new Function('return this._' + obj[0] + ';');
		}
	};

	var _creatMethods = function() {
		var obj, strString, strSerialize, strParse, strStringEnd, strSerializeEnd;

		strString = []; strSerialize = []; strParse = [];
		strStringEnd = ' + \',<br />\' + ';
		strSerializeEnd = ' + \'&\' + ';

		for (var i = 0, l = p_obj.length; i < l; i++) {
			obj = p_obj[i];

			if (obj[1] && obj[1].type) {
				_type = obj[1].type.toLowerCase();
			} else { _type = ''; }

			if (_type !== 'array') {
				strString.push('\'' + obj[0] + ': \' + ' + 'this._' + obj[0] + strStringEnd);
			} else {
				strString.push('\'' + obj[0] + ': [\' + ' + 'this._' + obj[0] + '.join(\', \') + \'],<br />\' + ');
			}

			strSerialize.push('\'' + obj[0] + '=\' + ' + 'escape(this._' + obj[0] + ')' + strSerializeEnd);
			strParse.push('if (p_json.' + obj[0] + ') { this._' + obj[0] + ' = p_json.' + obj[0] + '; }\n');
		}

		strString = strString.join('').substr(0, strString.join('').length - strStringEnd.length);
		strSerialize = strSerialize.join('').substr(0, strSerialize.join('').length - strSerializeEnd.length);
		strParse = strParse.join('');

		_fcn.prototype.toString = new Function('return ' + strString + ';');
		_fcn.prototype.serialize = new Function('return ' + strSerialize + ';');
		_fcn.prototype.parse = new Function('p_json', 'if (p_json === undefined) { return false; } ' + strParse + '; return true;');
	};

	_createVars();
	_createGetSet();
	_creatMethods();

	return _fcn;
};